# Configure paths for GAUGE^3D
# Kenton Varda 11/14/2000
# stolen from Sam Lantinga
# stolen from Manish Singh
# stolen back from Frank Belew
# stolen from Manish Singh
# Shamelessly stolen from Owen Taylor

# Kenton says:  autoconf doesn't like C++.  Anyone know how to make
# it compile a C++ test program that links to gauge?

dnl AM_PATH_GAUGE3D([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for GAUGE^3D, and define GAUGE3D_CFLAGS and GAUGE3D_LIBS
dnl
AC_DEFUN(AM_PATH_GAUGE3D,
[
	dnl
	dnl Get the cflags and libraries from the gauge3d-config script
	dnl
	AC_ARG_WITH(gauge3d-prefix,[  --with-gauge3d-prefix=PFX   Prefix where GAUGE3D is installed (optional)],
	            gauge3d_prefix="$withval", gauge3d_prefix="")
	AC_ARG_WITH(gauge3d-exec-prefix,[  --with-gauge3d-exec-prefix=PFX Exec prefix where GAUGE3D is installed (optional)],
	            gauge3d_exec_prefix="$withval", gauge3d_exec_prefix="")

	if test x$gauge3d_exec_prefix != x ; then
		gauge3d_args="$gauge3d_args --exec-prefix=$gauge3d_exec_prefix"
		if test x${GAUGE3D_CONFIG+set} != xset ; then
			GAUGE3D_CONFIG=$gauge3d_exec_prefix/bin/gauge3d-config
		fi
	fi
	if test x$gauge3d_prefix != x ; then
		gauge3d_args="$gauge3d_args --prefix=$gauge3d_prefix"
		if test x${GAUGE3D_CONFIG+set} != xset ; then
			GAUGE3D_CONFIG=$gauge3d_prefix/bin/gauge3d-config
		fi
	fi
	
	AC_PATH_PROG(GAUGE3D_CONFIG, gauge3d-config, no)
	
	min_gauge3d_version=ifelse([$1], ,0.1.0,$1)
	AC_MSG_CHECKING(for GAUGE3D - version >= $min_gauge3d_version)
	
	min_gauge3d_major_version=`echo $min_gauge3d_version | \
		sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
	min_gauge3d_minor_version=`echo $min_gauge3d_version | \
		sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
	min_gauge3d_micro_version=`echo $min_gauge3d_version | \
		sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
	
	no_gauge3d=""
	if test "$GAUGE3D_CONFIG" = "no" ; then
		no_gauge3d=yes
	else
		GAUGE3D_CFLAGS=`$GAUGE3D_CONFIG $gauge3dconf_args --cflags`
		GAUGE3D_LIBS=`$GAUGE3D_CONFIG $gauge3dconf_args --libs`
		
		gauge3d_version=`$GAUGE3D_CONFIG $gauge3d_config_args --version`
		gauge3d_major_version=`echo $gauge3d_version | \
			sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
		gauge3d_minor_version=`echo $gauge3d_version | \
			sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
		gauge3d_micro_version=`echo $gauge3d_version | \
			sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
		
		dnl See?  We don't need a C program to do this.
		if test $gauge3d_major_version -lt $min_gauge3d_major_version; then
			no_gauge3d=yes
		elif test $gauge3d_major_version -eq $min_gauge3d_major_version; then
			if test $gauge3d_minor_version -lt $min_gauge3d_minor_version; then
				no_gauge3d=yes
			elif test $gauge3d_minor_version -eq $min_gauge3d_minor_version; then
				if test $gauge3d_micro_version -lt $min_gauge3d_micro_version; then
					no_gauge3d=yes
				fi
			fi
		fi
	fi
	
	if test "x$no_gauge3d" = x ; then
		AC_MSG_RESULT(yes)
		ifelse([$2], , :, [$2])
	else
		AC_MSG_RESULT(no)
		if test "$GAUGE3D_CONFIG" = "no" ; then
			echo "*** The gauge3d-config script installed by GAUGE3D could not be found"
			echo "*** If GAUGE3D was installed in PREFIX, make sure PREFIX/bin is in"
			echo "*** your path, or set the GAUGE3D_CONFIG environment variable to the"
			echo "*** full path to gauge3d-config."
		else
			echo "*** 'gauge3d-config --version' returned $gauge3d_version, but the minimum"
			echo "*** version of GAUGE3D required is $min_gauge3d_version. If gauge3d-config"
			echo "*** is correct, then it is best to upgrade to the required version."
			echo "*** If gauge3d-config was wrong, set the environment variable GAUGE3D_CONFIG"
			echo "*** to point to the correct copy of gauge3d-config, and remove the file"
			echo "*** config.cache before re-running configure"
		fi
		GAUGE3D_CFLAGS=""
		GAUGE3D_LIBS=""
		ifelse([$3], , :, [$3])
	fi
	AC_SUBST(GAUGE3D_CFLAGS)
	AC_SUBST(GAUGE3D_LIBS)
])
