#! /usr/bin/perl

# This script is used to build the includes for GAUGE.  It should be invoked
# from this directory.  After running the script, the directory "include" will
# contain the headers which should be placed in /usr/local/include/gauge3d (or
# in ...\VC98\Include\gauge3d for MSVC).  Normally, you will not have to use
# this.

# Written (very quickly) by Boon Chew  (with some modification by Temporal)

#
# Substitue #include "gauge3d/blah blah" with #include <gauge3d/blah blah>
#
use strict 'subs';
use File::Find;
use Cwd;

$srcDir = "gauge3d";

$param = shift;

# be sure this is a full path -- mkdir seems to want full paths  (?)
$targetDir = getcwd() . "/include";

mkdir $targetDir, 0755 if(!-e $targetDir);

open(MAKEFILE, ">$targetDir/Makefile.am");
print MAKEFILE "ourincludedir      = \$(includedir)/gauge3d\n\n";
print MAKEFILE "SUBDIRS            = common 3dmath graphics ";
print MAKEFILE "osabstraction files input plugins renderer\n\n";
print MAKEFILE "ourinclude_HEADERS = ";
close(MAKEFILE);

sub ProcessFile
{
	if (-d)
	{
		return if ($_ eq "CVS");
		return if ($_ eq "templates");
		return if ($_ =~ /^\./);
		$dir = $File::Find::name;
		print $dir, "\n" if ($param eq "-v");
		$dir  =~ s/$srcDir/$targetDir/;
		mkdir $dir, 0755 if (!-e $dir);
		
		open(MAKEFILE, ">$dir/Makefile.am");
		print MAKEFILE "ourincludedir      = \$(includedir)/$File::Find::name\n\n";
		print MAKEFILE "ourinclude_HEADERS = ";
		close(MAKEFILE);
	}
	else
	{
		$filename = $_;
		return if (!($filename =~ /\.h$/));

		print $File::Find::name, "\n" if ($param eq "-v");
		open(FILE, "$filename") or die "Error opening file $_";
		
		$outfile = $File::Find::name;
		$outfile =~ s/$srcDir/$targetDir/;

		open(OUTFILE, ">$outfile") or die "Error opening file $outfile";
		
		$lineno = 0;
		while (<FILE>)
		{
			$lineno++;
			s/#include \"gauge3d\/([^"]*)\"/#include <gauge3d\/$1>/;
			print OUTFILE;
		}
		close(FILE);
		close(OUTFILE);
		
		$dir = $outfile;
		$dir =~ s/\/$filename$//;
		open(MAKEFILE, ">>$dir/Makefile.am");
		print MAKEFILE "$filename ";
		close(MAKEFILE);
	}
}

find(\&ProcessFile, $srcDir);
0;


