/* GAUGE^3D - Grand Unified (3D) Game Engine
 * Direct3D 7 Rendering Plugin
 * Copyright (C) 2000 Steven Haworth
 * <http://www.gauge3d.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/*
 *     Filename: d3d7renderer.h
 *      Package: Direct3D 7 Rendering Plugin
 *    Component: Renderer
 *  Description: serves rendering classes
 * Dependencies: GpD3D7*
 */

#ifndef __GAUGE3D_PLUGIN_RENDERER_DIRECT3D7_D3D7RENDERER_H__INCLUDED__
#define __GAUGE3D_PLUGIN_RENDERER_DIRECT3D7_D3D7RENDERER_H__INCLUDED__

#ifndef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION 0x0700
#define DIRECT3D_VERSION    0x0700
#endif

// includes ==========================================================
// stddefs.h ---------------------------------------------------------
#ifndef __GAUGE3D_STDDEFS_H__INCLUDED__
#include "gauge3d/stddefs.h"
#endif //redundant include guard

// system ------------------------------------------------------------
#ifndef __SYSTEM_DDRAW_H__INCLUDED__
#include <ddraw.h>
#define __SYSTEM_DDRAW_H__INCLUDED__
#endif //redundant include guard

// GAUGE^3D ----------------------------------------------------------
#ifndef __GAUGE3D_RENDERER_RENDERER_H__INCLUDED__
#include "gauge3d/renderer/renderer.h"
#endif

// local package -----------------------------------------------------
#ifndef __GAUGE3D_RENDERER_DIRECT3D_D3D7DISPLAY_H__INCLUDED__
#include "d3d7display.h"
#endif

#ifndef __LOCAL_DXERROR_H__INCLUDED__
#include "dxerror.h"
#define __LOCAL_DXERROR_H__INCLUDED__
#endif

// begin namespace ===================================================
namespace GAUGE3D {
namespace Plugins {

// class definition ==================================================
class GpD3D7Renderer: public GRenderer
{
	GAUGE3D_SET_UID(0x00000048, 0x54846eca, 0x3978227b)
public:
	// lifecycle -------------------------------------------------------
	GpD3D7Renderer();
	virtual ~GpD3D7Renderer();
	
	// operations ------------------------------------------------------
	virtual pGDisplay NewDisplay();
	virtual pGTexture NewTexture();
	virtual pGScene   NewScene();

private:
	GError *mError;
	LPDIRECTDRAW7 mIDirectDraw;
	GpD3D7Display *mDisplay;
};

} //namespace Plugins
} //namespace GAUGE3D

#endif //included
