/* GAUGE^3D - Grand Unified (3D) Game Engine
 * Copyright (C) 2000 Kenton Varda
 * <http://www.gauge3d.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

// ===================================================================

/*
 *     Filename: glrenderer.h
 *      Package: OpenGL Rendering Plugin
 *    Component: Renderer
 *  Description: serves rendering classes
 * Dependencies: GpGL*
 */

#ifndef __GAUGE3D_PLUGIN_RENDERER_OPENGL_GLRENDERER_H__INCLUDED__
#define __GAUGE3D_PLUGIN_RENDERER_OPENGL_GLRENDERER_H__INCLUDED__

// includes ==========================================================
// stddefs.h ---------------------------------------------------------
#ifndef __GAUGE3D_STDDEFS_H__INCLUDED__
#include "gauge3d/stddefs.h"
#endif //redundant include guard

// system ------------------------------------------------------------
// GAUGE^3D ----------------------------------------------------------
#ifndef __GAUGE3D_RENDERER_RENDERER_H__INCLUDED__
#include "gauge3d/renderer/renderer.h"
#endif

// local package -----------------------------------------------------

// begin namespace ===================================================
namespace GAUGE3D {
namespace Plugins {

// class definition ==================================================
class GpGLRenderer: public GRenderer
{
	GAUGE3D_SET_UID(0x00000048, 0x54846eca, 0x39782219)
public:
	// lifecycle -------------------------------------------------------
	GpGLRenderer();
	virtual ~GpGLRenderer();
	
	// operations ------------------------------------------------------
	virtual pGDisplay NewDisplay();
	virtual pGTexture NewTexture();
	virtual pGScene   NewScene();
};

} //namespace Plugins
} //namespace GAUGE3D

#endif //included
